/* Generated By:JavaCC: Do not edit this line. VersionParser.java */
package org.commonjava.maven.atlas.common.version.parse;

import org.commonjava.maven.atlas.common.version.*;
import org.commonjava.maven.atlas.common.version.part.*;
import org.commonjava.maven.atlas.common.version.transform.*;
import java.util.*;
import java.text.*;
import java.io.*;

public class VersionParser implements VersionParserConstants {
    private String rawSpec;

    public static void main( String[] args )
        throws Exception
    {
        BufferedReader reader = new BufferedReader( new InputStreamReader( System.in ) );
        while( true )
        {
        try
        {
            System.out.print( "Enter version specification: " );
            String expr = reader.readLine();
            VersionParser parser = new VersionParser( expr );
            VersionSpec version = parser.parse();
            System.out.println( version );
        }
        catch ( ParseException e )
        {
            e.printStackTrace();
        }
        }
    }

    public VersionParser( String expression )
    {
        this( (Reader)(new StringReader( expression ) ) );
        this.rawSpec = expression;
    }

    private RangeVersionSpec getRangeVersionSpec( SingleVersion lower, SingleVersion upper, boolean lowerInclusive, boolean upperInclusive )
    {
      return new RangeVersionSpec( rawSpec, lower, upper, lowerInclusive, upperInclusive );
    }

    private CompoundVersionSpec getCompoundVersionSpec( List<VersionSpec> specs )
    {
      return new CompoundVersionSpec( rawSpec, specs );
    }

    private SnapshotPart newSnapshotPart( String date, String buildnum )
      throws ParseException
    {
      try
      {
        return new SnapshotPart( SnapshotSupport.parseSnapshotTimestamp( date ), Integer.parseInt( buildnum ), date + "-" + buildnum );
      }
      catch ( java.text.ParseException e )
      {
        ParseException pe = new ParseException( "Failed to parse snapshot timestamp: '" + date + "'. Error: " + e.getMessage() );
        pe.initCause( e );

        throw pe;
      }
      catch ( NumberFormatException e )
      {
        ParseException pe = new ParseException( "Failed to parse snapshot build number: '" + buildnum + "'. Error: " + e.getMessage() );
        pe.initCause( e );

        throw pe;
      }
    }

    private void addPart( List<VersionPart> parts, VersionPart current, VersionPart last )
    {
      if ( last != null )
      {
        if ( !(last instanceof SeparatorPart) && !(current instanceof SeparatorPart))
        {
          parts.add( new SeparatorPart( VersionPartSeparator.BLANK ) );
        }
      }

      parts.add( current );
    }

  final public VersionSpec parse() throws ParseException, InvalidVersionSpecificationException {
 VersionSpec version = null;
    version = anySpec();
    {if (true) return version;}
    throw new Error("Missing return statement in function");
  }

  final public VersionSpec anySpec() throws ParseException, InvalidVersionSpecificationException {
List<VersionSpec> versions=new ArrayList<VersionSpec>();
VersionSpec version=null;
    label_1:
    while (true) {
      if (jj_2_1(20)) {
        ;
      } else {
        break label_1;
      }
      version = anySingleSpec();
     versions.add( version );
    }
    if ( versions.isEmpty() )
    {
        {if (true) throw new InvalidVersionSpecificationException( rawSpec, "Cannot parse; no version specs found!");}
    }
    else if ( versions.size() == 1 )
    {
        {if (true) return versions.iterator().next();}
    }
    else
    {
        {if (true) return getCompoundVersionSpec( versions );}
    }
    throw new Error("Missing return statement in function");
  }

  final public VersionSpec anySingleSpec() throws ParseException, InvalidVersionSpecificationException {
VersionSpec version = null;
    if (jj_2_2(20)) {
      version = range();
    } else if (jj_2_3(20)) {
      version = single();
    } else {
      jj_consume_token(-1);
      throw new ParseException();
    }
    {if (true) return version;}
    throw new Error("Missing return statement in function");
  }

  final public RangeVersionSpec range() throws ParseException, InvalidVersionSpecificationException {
RangeVersionSpec spec=null;
    if (jj_2_4(20)) {
      spec = trueRange();
    } else if (jj_2_5(20)) {
      spec = pinnedRange();
    } else {
      jj_consume_token(-1);
      throw new ParseException();
    }
      {if (true) return spec;}
    throw new Error("Missing return statement in function");
  }

  final public RangeVersionSpec trueRange() throws ParseException, InvalidVersionSpecificationException {
SingleVersion lower=null;
boolean lowerInclusive=true;
SingleVersion upper=null;
boolean upperInclusive=true;
    if (jj_2_6(20)) {
      jj_consume_token(LPAREN);
      lowerInclusive=false;
    } else if (jj_2_7(20)) {
      jj_consume_token(LBRAK);
      lowerInclusive=true;
    } else {
      jj_consume_token(-1);
      throw new ParseException();
    }
    if (jj_2_8(20)) {
      lower = single();
    } else {
      ;
    }
    jj_consume_token(COMMA);
    if (jj_2_9(20)) {
      upper = single();
    } else {
      ;
    }
    if (jj_2_10(20)) {
      jj_consume_token(RPAREN);
      upperInclusive=false;
    } else if (jj_2_11(20)) {
      jj_consume_token(RBRAK);
      upperInclusive=true;
    } else {
      jj_consume_token(-1);
      throw new ParseException();
    }
    {if (true) return getRangeVersionSpec( lower, upper, lowerInclusive, upperInclusive );}
    throw new Error("Missing return statement in function");
  }

  final public RangeVersionSpec pinnedRange() throws ParseException, InvalidVersionSpecificationException {
SingleVersion version=null;
    jj_consume_token(LBRAK);
    version = single();
    jj_consume_token(RBRAK);
    {if (true) return getRangeVersionSpec( version, version, true, true );}
    throw new Error("Missing return statement in function");
  }

  final public SingleVersion single() throws ParseException, InvalidVersionSpecificationException {
List<VersionPart> parts = new ArrayList<VersionPart>();
VersionPart seg=null;
VersionPart last = null;
    seg = segment();
    if ( ( seg instanceof StringPart ) && ((StringPart)seg).getValue().indexOf(".") > -1 )
    {
        String[] subParts = ((StringPart)seg).getValue().split("\u005c\u005c.");
        for( int subIdx=0; subIdx<subParts.length; subIdx++ )
        {
            NumericPart subSeg = new NumericPart( subParts[subIdx] );
            addPart( parts, subSeg, last );
            last = subSeg;

            if ( subIdx+1 < subParts.length )
            {
                SeparatorPart sepPart = new SeparatorPart( VersionPartSeparator.DOT );
                addPart( parts, sepPart, last );
                last = sepPart;
            }
        }
    }
    else
    {
        addPart( parts, seg, last );
        last = seg;
    }
    label_2:
    while (true) {
      if (jj_2_12(20)) {
        ;
      } else {
        break label_2;
      }
      if (jj_2_13(20)) {
        seg = separator();
        addPart( parts, seg, last );
        last = seg;
      } else {
        ;
      }
      if (jj_2_14(20)) {
        seg = snapshot();
          addPart( parts, seg, last );
          last = seg;
      } else if (jj_2_15(20)) {
        seg = segment();
          if ( ( seg instanceof StringPart ) && ((StringPart)seg).getValue().indexOf(".") > -1 )
          {
              String[] subParts = ((StringPart)seg).getValue().split("\u005c\u005c.");
              for( int subIdx=0; subIdx<subParts.length; subIdx++ )
              {
                  NumericPart subSeg = new NumericPart( subParts[subIdx] );
                  addPart( parts, subSeg, last );
                  last = subSeg;

                  if ( subIdx+1 < subParts.length )
                  {
                      SeparatorPart sepPart = new SeparatorPart( VersionPartSeparator.DOT );
                      addPart( parts, sepPart, last );
                      last = sepPart;
                  }
              }
          }
          else
          {
              addPart( parts, seg, last );
              last = seg;
          }
      } else {
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    {if (true) return new SingleVersion( rawSpec, parts );}
    throw new Error("Missing return statement in function");
  }

  final public VersionPart segment() throws ParseException {
VersionPart part = null;
StringBuilder num = new StringBuilder();
Token val=null;
    if (jj_2_17(20)) {
      part = snapshot();
    } else if (jj_2_18(20)) {
      val = jj_consume_token(SNAPDATE);
     part = new StringPart(val.image);
    } else if (jj_2_19(20)) {
      label_3:
      while (true) {
        val = jj_consume_token(DIGIT);
     num.append(val.image);
        if (jj_2_16(20)) {
          ;
        } else {
          break label_3;
        }
      }
    } else if (jj_2_20(20)) {
      val = jj_consume_token(STRING);
     part = new StringPart(val.image);
    } else {
      jj_consume_token(-1);
      throw new ParseException();
    }
 {if (true) return part == null ? new NumericPart( num.toString() ) : part;}
    throw new Error("Missing return statement in function");
  }

  final public VersionPart snapshot() throws ParseException {
SnapshotPart part = null;
String ts = null;
StringBuilder bn = new StringBuilder();
Token token = null;
    if (jj_2_22(20)) {
      token = jj_consume_token(SNAPDATE);
       ts = token.image;
      jj_consume_token(DASH);
      label_4:
      while (true) {
        token = jj_consume_token(DIGIT);
       bn.append(token.image);
        if (jj_2_21(20)) {
          ;
        } else {
          break label_4;
        }
      }
    } else if (jj_2_23(20)) {
      token = jj_consume_token(LSNAP);
     part = new SnapshotPart(token.image);
    } else {
      jj_consume_token(-1);
      throw new ParseException();
    }
 {if (true) return part == null ? newSnapshotPart( ts, bn.toString() ) : part;}
    throw new Error("Missing return statement in function");
  }

  final public SeparatorPart separator() throws ParseException {
VersionPartSeparator sep = null;
    if (jj_2_24(20)) {
      jj_consume_token(DOT);
   sep = VersionPartSeparator.DOT;
    } else if (jj_2_25(20)) {
      jj_consume_token(DASH);
   sep = VersionPartSeparator.DASH;
    } else if (jj_2_26(20)) {
      jj_consume_token(USCORE);
   sep = VersionPartSeparator.UNDERSCORE;
    } else {
      jj_consume_token(-1);
      throw new ParseException();
    }
   {if (true) return new SeparatorPart( sep );}
    throw new Error("Missing return statement in function");
  }

  private boolean jj_2_1(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_1(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(0, xla); }
  }

  private boolean jj_2_2(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_2(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(1, xla); }
  }

  private boolean jj_2_3(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_3(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(2, xla); }
  }

  private boolean jj_2_4(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_4(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(3, xla); }
  }

  private boolean jj_2_5(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_5(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(4, xla); }
  }

  private boolean jj_2_6(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_6(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(5, xla); }
  }

  private boolean jj_2_7(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_7(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(6, xla); }
  }

  private boolean jj_2_8(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_8(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(7, xla); }
  }

  private boolean jj_2_9(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_9(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(8, xla); }
  }

  private boolean jj_2_10(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_10(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(9, xla); }
  }

  private boolean jj_2_11(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_11(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(10, xla); }
  }

  private boolean jj_2_12(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_12(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(11, xla); }
  }

  private boolean jj_2_13(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_13(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(12, xla); }
  }

  private boolean jj_2_14(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_14(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(13, xla); }
  }

  private boolean jj_2_15(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_15(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(14, xla); }
  }

  private boolean jj_2_16(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_16(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(15, xla); }
  }

  private boolean jj_2_17(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_17(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(16, xla); }
  }

  private boolean jj_2_18(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_18(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(17, xla); }
  }

  private boolean jj_2_19(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_19(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(18, xla); }
  }

  private boolean jj_2_20(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_20(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(19, xla); }
  }

  private boolean jj_2_21(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_21(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(20, xla); }
  }

  private boolean jj_2_22(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_22(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(21, xla); }
  }

  private boolean jj_2_23(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_23(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(22, xla); }
  }

  private boolean jj_2_24(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_24(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(23, xla); }
  }

  private boolean jj_2_25(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_25(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(24, xla); }
  }

  private boolean jj_2_26(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_26(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(25, xla); }
  }

  private boolean jj_3R_12() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_17()) {
    jj_scanpos = xsp;
    if (jj_3_18()) {
    jj_scanpos = xsp;
    if (jj_3_19()) {
    jj_scanpos = xsp;
    if (jj_3_20()) return true;
    }
    }
    }
    return false;
  }

  private boolean jj_3_13() {
    if (jj_3R_10()) return true;
    return false;
  }

  private boolean jj_3_23() {
    if (jj_scan_token(LSNAP)) return true;
    return false;
  }

  private boolean jj_3_21() {
    if (jj_scan_token(DIGIT)) return true;
    return false;
  }

  private boolean jj_3R_9() {
    if (jj_scan_token(LBRAK)) return true;
    if (jj_3R_7()) return true;
    if (jj_scan_token(RBRAK)) return true;
    return false;
  }

  private boolean jj_3_5() {
    if (jj_3R_9()) return true;
    return false;
  }

  private boolean jj_3_12() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_13()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3_14()) {
    jj_scanpos = xsp;
    if (jj_3_15()) return true;
    }
    return false;
  }

  private boolean jj_3_4() {
    if (jj_3R_8()) return true;
    return false;
  }

  private boolean jj_3R_6() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_4()) {
    jj_scanpos = xsp;
    if (jj_3_5()) return true;
    }
    return false;
  }

  private boolean jj_3_22() {
    if (jj_scan_token(SNAPDATE)) return true;
    if (jj_scan_token(DASH)) return true;
    Token xsp;
    if (jj_3_21()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_21()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  private boolean jj_3_11() {
    if (jj_scan_token(RBRAK)) return true;
    return false;
  }

  private boolean jj_3R_11() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_22()) {
    jj_scanpos = xsp;
    if (jj_3_23()) return true;
    }
    return false;
  }

  private boolean jj_3_3() {
    if (jj_3R_7()) return true;
    return false;
  }

  private boolean jj_3_2() {
    if (jj_3R_6()) return true;
    return false;
  }

  private boolean jj_3_10() {
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  private boolean jj_3R_5() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_2()) {
    jj_scanpos = xsp;
    if (jj_3_3()) return true;
    }
    return false;
  }

  private boolean jj_3_9() {
    if (jj_3R_7()) return true;
    return false;
  }

  private boolean jj_3_8() {
    if (jj_3R_7()) return true;
    return false;
  }

  private boolean jj_3_7() {
    if (jj_scan_token(LBRAK)) return true;
    return false;
  }

  private boolean jj_3R_7() {
    if (jj_3R_12()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_12()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  private boolean jj_3_26() {
    if (jj_scan_token(USCORE)) return true;
    return false;
  }

  private boolean jj_3_20() {
    if (jj_scan_token(STRING)) return true;
    return false;
  }

  private boolean jj_3_6() {
    if (jj_scan_token(LPAREN)) return true;
    return false;
  }

  private boolean jj_3_16() {
    if (jj_scan_token(DIGIT)) return true;
    return false;
  }

  private boolean jj_3_25() {
    if (jj_scan_token(DASH)) return true;
    return false;
  }

  private boolean jj_3_15() {
    if (jj_3R_12()) return true;
    return false;
  }

  private boolean jj_3R_8() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_6()) {
    jj_scanpos = xsp;
    if (jj_3_7()) return true;
    }
    xsp = jj_scanpos;
    if (jj_3_8()) jj_scanpos = xsp;
    if (jj_scan_token(COMMA)) return true;
    xsp = jj_scanpos;
    if (jj_3_9()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3_10()) {
    jj_scanpos = xsp;
    if (jj_3_11()) return true;
    }
    return false;
  }

  private boolean jj_3_24() {
    if (jj_scan_token(DOT)) return true;
    return false;
  }

  private boolean jj_3_19() {
    Token xsp;
    if (jj_3_16()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_16()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  private boolean jj_3R_10() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_24()) {
    jj_scanpos = xsp;
    if (jj_3_25()) {
    jj_scanpos = xsp;
    if (jj_3_26()) return true;
    }
    }
    return false;
  }

  private boolean jj_3_18() {
    if (jj_scan_token(SNAPDATE)) return true;
    return false;
  }

  private boolean jj_3_14() {
    if (jj_3R_11()) return true;
    return false;
  }

  private boolean jj_3_1() {
    if (jj_3R_5()) return true;
    return false;
  }

  private boolean jj_3_17() {
    if (jj_3R_11()) return true;
    return false;
  }

  /** Generated Token Manager. */
  public VersionParserTokenManager token_source;
  SimpleCharStream jj_input_stream;
  /** Current token. */
  public Token token;
  /** Next token. */
  public Token jj_nt;
  private int jj_ntk;
  private Token jj_scanpos, jj_lastpos;
  private int jj_la;
  private int jj_gen;
  final private int[] jj_la1 = new int[0];
  static private int[] jj_la1_0;
  static {
      jj_la1_init_0();
   }
   private static void jj_la1_init_0() {
      jj_la1_0 = new int[] {};
   }
  final private JJCalls[] jj_2_rtns = new JJCalls[26];
  private boolean jj_rescan = false;
  private int jj_gc = 0;

  /** Constructor with InputStream. */
  public VersionParser(java.io.InputStream stream) {
     this(stream, null);
  }
  /** Constructor with InputStream and supplied encoding */
  public VersionParser(java.io.InputStream stream, String encoding) {
    try { jj_input_stream = new SimpleCharStream(stream, encoding, 1, 1); } catch(java.io.UnsupportedEncodingException e) { throw new RuntimeException(e); }
    token_source = new VersionParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 0; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  /** Reinitialise. */
  public void ReInit(java.io.InputStream stream) {
     ReInit(stream, null);
  }
  /** Reinitialise. */
  public void ReInit(java.io.InputStream stream, String encoding) {
    try { jj_input_stream.ReInit(stream, encoding, 1, 1); } catch(java.io.UnsupportedEncodingException e) { throw new RuntimeException(e); }
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 0; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  /** Constructor. */
  public VersionParser(java.io.Reader stream) {
    jj_input_stream = new SimpleCharStream(stream, 1, 1);
    token_source = new VersionParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 0; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  /** Reinitialise. */
  public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 0; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  /** Constructor with generated Token Manager. */
  public VersionParser(VersionParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 0; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  /** Reinitialise. */
  public void ReInit(VersionParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 0; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      if (++jj_gc > 100) {
        jj_gc = 0;
        for (int i = 0; i < jj_2_rtns.length; i++) {
          JJCalls c = jj_2_rtns[i];
          while (c != null) {
            if (c.gen < jj_gen) c.first = null;
            c = c.next;
          }
        }
      }
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }

  static private final class LookaheadSuccess extends java.lang.Error { }
  final private LookaheadSuccess jj_ls = new LookaheadSuccess();
  private boolean jj_scan_token(int kind) {
    if (jj_scanpos == jj_lastpos) {
      jj_la--;
      if (jj_scanpos.next == null) {
        jj_lastpos = jj_scanpos = jj_scanpos.next = token_source.getNextToken();
      } else {
        jj_lastpos = jj_scanpos = jj_scanpos.next;
      }
    } else {
      jj_scanpos = jj_scanpos.next;
    }
    if (jj_rescan) {
      int i = 0; Token tok = token;
      while (tok != null && tok != jj_scanpos) { i++; tok = tok.next; }
      if (tok != null) jj_add_error_token(kind, i);
    }
    if (jj_scanpos.kind != kind) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) throw jj_ls;
    return false;
  }


/** Get the next Token. */
  final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

/** Get the specific Token. */
  final public Token getToken(int index) {
    Token t = token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  private java.util.List<int[]> jj_expentries = new java.util.ArrayList<int[]>();
  private int[] jj_expentry;
  private int jj_kind = -1;
  private int[] jj_lasttokens = new int[100];
  private int jj_endpos;

  private void jj_add_error_token(int kind, int pos) {
    if (pos >= 100) return;
    if (pos == jj_endpos + 1) {
      jj_lasttokens[jj_endpos++] = kind;
    } else if (jj_endpos != 0) {
      jj_expentry = new int[jj_endpos];
      for (int i = 0; i < jj_endpos; i++) {
        jj_expentry[i] = jj_lasttokens[i];
      }
      jj_entries_loop: for (java.util.Iterator<?> it = jj_expentries.iterator(); it.hasNext();) {
        int[] oldentry = (int[])(it.next());
        if (oldentry.length == jj_expentry.length) {
          for (int i = 0; i < jj_expentry.length; i++) {
            if (oldentry[i] != jj_expentry[i]) {
              continue jj_entries_loop;
            }
          }
          jj_expentries.add(jj_expentry);
          break jj_entries_loop;
        }
      }
      if (pos != 0) jj_lasttokens[(jj_endpos = pos) - 1] = kind;
    }
  }

  /** Generate ParseException. */
  public ParseException generateParseException() {
    jj_expentries.clear();
    boolean[] la1tokens = new boolean[14];
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 0; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 14; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.add(jj_expentry);
      }
    }
    jj_endpos = 0;
    jj_rescan_token();
    jj_add_error_token(0, 0);
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = jj_expentries.get(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  /** Enable tracing. */
  final public void enable_tracing() {
  }

  /** Disable tracing. */
  final public void disable_tracing() {
  }

  private void jj_rescan_token() {
    jj_rescan = true;
    for (int i = 0; i < 26; i++) {
    try {
      JJCalls p = jj_2_rtns[i];
      do {
        if (p.gen > jj_gen) {
          jj_la = p.arg; jj_lastpos = jj_scanpos = p.first;
          switch (i) {
            case 0: jj_3_1(); break;
            case 1: jj_3_2(); break;
            case 2: jj_3_3(); break;
            case 3: jj_3_4(); break;
            case 4: jj_3_5(); break;
            case 5: jj_3_6(); break;
            case 6: jj_3_7(); break;
            case 7: jj_3_8(); break;
            case 8: jj_3_9(); break;
            case 9: jj_3_10(); break;
            case 10: jj_3_11(); break;
            case 11: jj_3_12(); break;
            case 12: jj_3_13(); break;
            case 13: jj_3_14(); break;
            case 14: jj_3_15(); break;
            case 15: jj_3_16(); break;
            case 16: jj_3_17(); break;
            case 17: jj_3_18(); break;
            case 18: jj_3_19(); break;
            case 19: jj_3_20(); break;
            case 20: jj_3_21(); break;
            case 21: jj_3_22(); break;
            case 22: jj_3_23(); break;
            case 23: jj_3_24(); break;
            case 24: jj_3_25(); break;
            case 25: jj_3_26(); break;
          }
        }
        p = p.next;
      } while (p != null);
      } catch(LookaheadSuccess ls) { }
    }
    jj_rescan = false;
  }

  private void jj_save(int index, int xla) {
    JJCalls p = jj_2_rtns[index];
    while (p.gen > jj_gen) {
      if (p.next == null) { p = p.next = new JJCalls(); break; }
      p = p.next;
    }
    p.gen = jj_gen + xla - jj_la; p.first = token; p.arg = xla;
  }

  static final class JJCalls {
    int gen;
    Token first;
    int arg;
    JJCalls next;
  }

}
